#region Using declarations
using System;
using System.ComponentModel;
using System.Diagnostics;
using System.Drawing;
using System.Drawing.Drawing2D;
using System.Xml.Serialization;
using NinjaTrader.Cbi;
using NinjaTrader.Data;
using NinjaTrader.Gui.Chart;
using System.IO;
using System.Text;
#endregion

// This namespace holds all indicators and is required. Do not change it.
namespace NinjaTrader.Indicator
{
    /// <summary>
    /// 
    /// </summary>
    [Description("")]
    public class Vols : Indicator
    {
        #region Variables
        // Wizard generated variables
        // User defined variables (add any user defined variables below)
        #endregion

		//StreamWriter writer;//= new StreamWriter(@"C:\extremes.csv");
		
		protected override void OnStartUp() 
		{
			//writer = new StreamWriter(@"C:\extremes1.csv");
		}
		
        protected override void Initialize()
        {
            Add(new Plot(Color.FromKnownColor(KnownColor.Orange), PlotStyle.Bar, "CurrentDeviation"));
			Add(new Plot(Color.FromKnownColor(KnownColor.White), PlotStyle.Line, "Sdev35"));
			Add(new Plot(Color.FromKnownColor(KnownColor.White), PlotStyle.Line, "SdevNeg35"));
			
			AutoScale = true;
			
            Overlay				= false;
			BarsRequired = 300;
        }

        /// <summary>
        /// Called on each bar update event (incoming tick)
        /// </summary>
        protected override void OnBarUpdate()
        {
			if( CurrentBar < BarsRequired )
				return;
			
			int STOP_COUNT = 300;
			
			double average = 0;
				
			for( int i = 0; i < STOP_COUNT; i++)
			{
				average += (Close[i]-Close[i+1])/Close[i];
			}
				
			average /= STOP_COUNT;
							
			double variance = 0;
			double temp;
			
			for( int j = 0; j < STOP_COUNT; j++)
			{
				temp = (Close[j+1]-Close[j])/Close[j];
				variance += Math.Pow( temp - average,2);				
			}
			
			double divisor = STOP_COUNT - 1;
			variance = variance / divisor;	
				
			double sDev = Math.Sqrt( variance );
			double sDevNow = ((Close[0]-Close[1])/Close[0])/ sDev;
			
			///string info = String.Format("{0},{1},{2},{3}", average, variance, sDev, ( (Math.Log(High[0]-Low[0])-average )/ sDev));
			string info = String.Format("{0}", sDevNow);
			Print(info);
			//writer.WriteLine(info);
			
            //CurrentDeviation.Set( (Math.Log(High[0]-Low[0]) / sDev ) );
			CurrentDeviation.Set( sDevNow );
			Sdev35.Set( 3.5 );
			SdevNeg35.Set( -3.5 );
        }
		
		protected override void OnTermination() {
			//writer.Close();	
		}
		
        #region Properties
        [Browsable(false)]	// this line prevents the data series from being displayed in the indicator properties dialog, do not remove
        [XmlIgnore()]		// this line ensures that the indicator can be saved/recovered as part of a chart template, do not remove
        public DataSeries CurrentDeviation
        {
            get { return Values[0]; }
        }

        [Browsable(false)]	// this line prevents the data series from being displayed in the indicator properties dialog, do not remove
        [XmlIgnore()]		// this line ensures that the indicator can be saved/recovered as part of a chart template, do not remove
        public DataSeries Sdev35
        {
            get { return Values[1]; }
        }
		
        [Browsable(false)]	// this line prevents the data series from being displayed in the indicator properties dialog, do not remove
        [XmlIgnore()]		// this line ensures that the indicator can be saved/recovered as part of a chart template, do not remove
        public DataSeries SdevNeg35
        {
            get { return Values[2]; }
        }		

        #endregion
    }
}

#region NinjaScript generated code. Neither change nor remove.
// This namespace holds all indicators and is required. Do not change it.
namespace NinjaTrader.Indicator
{
    public partial class Indicator : IndicatorBase
    {
        private Vols[] cacheVols = null;

        private static Vols checkVols = new Vols();

        /// <summary>
        /// 
        /// </summary>
        /// <returns></returns>
        public Vols Vols()
        {
            return Vols(Input);
        }

        /// <summary>
        /// 
        /// </summary>
        /// <returns></returns>
        public Vols Vols(Data.IDataSeries input)
        {
            if (cacheVols != null)
                for (int idx = 0; idx < cacheVols.Length; idx++)
                    if (cacheVols[idx].EqualsInput(input))
                        return cacheVols[idx];

            lock (checkVols)
            {
                if (cacheVols != null)
                    for (int idx = 0; idx < cacheVols.Length; idx++)
                        if (cacheVols[idx].EqualsInput(input))
                            return cacheVols[idx];

                Vols indicator = new Vols();
                indicator.BarsRequired = BarsRequired;
                indicator.CalculateOnBarClose = CalculateOnBarClose;
#if NT7
                indicator.ForceMaximumBarsLookBack256 = ForceMaximumBarsLookBack256;
                indicator.MaximumBarsLookBack = MaximumBarsLookBack;
#endif
                indicator.Input = input;
                Indicators.Add(indicator);
                indicator.SetUp();

                Vols[] tmp = new Vols[cacheVols == null ? 1 : cacheVols.Length + 1];
                if (cacheVols != null)
                    cacheVols.CopyTo(tmp, 0);
                tmp[tmp.Length - 1] = indicator;
                cacheVols = tmp;
                return indicator;
            }
        }
    }
}

// This namespace holds all market analyzer column definitions and is required. Do not change it.
namespace NinjaTrader.MarketAnalyzer
{
    public partial class Column : ColumnBase
    {
        /// <summary>
        /// 
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator.Vols Vols()
        {
            return _indicator.Vols(Input);
        }

        /// <summary>
        /// 
        /// </summary>
        /// <returns></returns>
        public Indicator.Vols Vols(Data.IDataSeries input)
        {
            return _indicator.Vols(input);
        }
    }
}

// This namespace holds all strategies and is required. Do not change it.
namespace NinjaTrader.Strategy
{
    public partial class Strategy : StrategyBase
    {
        /// <summary>
        /// 
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator.Vols Vols()
        {
            return _indicator.Vols(Input);
        }

        /// <summary>
        /// 
        /// </summary>
        /// <returns></returns>
        public Indicator.Vols Vols(Data.IDataSeries input)
        {
            if (InInitialize && input == null)
                throw new ArgumentException("You only can access an indicator with the default input/bar series from within the 'Initialize()' method");

            return _indicator.Vols(input);
        }
    }
}
#endregion
